<!-- https://eugenkiss.github.io/7guis/tasks#crud -->
<script lang="ts">
  import { createProductGroupAPI } from "src/apis/create-product-group";
  import { deleteProductGroupAPI } from "src/apis/delete-product-group";
  import { getProductGroupAPI } from "src/apis/get-product-group";
  import { updateProductGroupAPI } from "src/apis/update-product-group";
  import type { ProductGroupModel } from "src/models/product.group.type";
  import { productGroupListStore, productTypeListStore } from "src/store";

  import { onMount } from "svelte";

  let disable = false;

  // **** Group
  let productGroupList: ProductGroupModel[] = [];
  let customCss = "";

  let typeName = "";
  let iconGroupUrl = "";
  let querySearch = "";

  let showFor = "";
  let typeSelectIndex = 0;

  async function updateTypeAPI() {
    await updateProductGroupAPI(selectedProductGroup);
    await reloadCallApi();
  }

  async function createGroupAPI(productGroup: ProductGroupModel) {
    await createProductGroupAPI(productGroup);
    await reloadCallApi();
  }

  async function deleteGroupAPI(uuid: string) {
    if (uuid) {
      await deleteProductGroupAPI(uuid);
      await reloadCallApi();
    }
  }

  $: filterTypeList = productGroupList;

  $: selectedProductGroup = filterTypeList[typeSelectIndex];

  $: reset_type_inputs(selectedProductGroup);

  async function createType() {
    productGroupList = productGroupList.concat({
      typeName: typeName,
      icon: iconGroupUrl,
      showFor: showFor,
      querySearch: querySearch,
    });
    typeSelectIndex = productGroupList.length - 1;

    await createGroupAPI({
      typeName: typeName,
      icon: iconGroupUrl,
      showFor: showFor,
      querySearch: querySearch,
    });

    typeName = "";
    iconGroupUrl = "";
    querySearch = "";
    showFor = "";
  }

  async function updateType() {
    selectedProductGroup.typeName = typeName;
    selectedProductGroup.icon = iconGroupUrl;
    selectedProductGroup.showFor = showFor;
    selectedProductGroup.querySearch = querySearch;
    productGroupList = productGroupList;
    await updateTypeAPI();
  }

  async function removeType() {
    // Remove selectedProductGroup person from the source array (productGroupList), not the filtered array
    const index = productGroupList.indexOf(selectedProductGroup);
    productGroupList = [
      ...productGroupList.slice(0, index),
      ...productGroupList.slice(index + 1),
    ];

    await deleteGroupAPI(selectedProductGroup.uuid || "");

    typeName = "";
    iconGroupUrl = "";
    querySearch = "";
    showFor = "";
    typeSelectIndex = Math.min(typeSelectIndex, filterTypeList.length - 2);
  }

  function reset_type_inputs(group: any) {
    typeName = group ? group.typeName : "";
    querySearch = group ? group.querySearch : ""
    iconGroupUrl = group ? group.icon : "";
    showFor = group ? group.showFor : "";
  }

  onMount(async () => {
    await reloadCallApi();
  });

  async function reloadCallApi() {
    await getProductGroupAPI();

    productGroupList = $productGroupListStore;
  }
</script>

<div class="w-full p-5 rounded bg-yellow-500 mx-3">
  <p class="text-white">จัดการกลุ่มสินค้า</p>
  <div class="flex flex-col p-3 bg-gray-200 rounded {customCss}">
    <select class="rounded" bind:value={typeSelectIndex} size={10}>
      {#each filterTypeList as typeData, typeSelectIndex}
        <option value={typeSelectIndex}
          >{typeSelectIndex + 1}. {typeData.typeName}
        </option>
      {/each}
    </select>

    {#if !disable}
      <p>ชื่อกลุ่ม</p>
      <input
        type="text"
        class="p-2 my-1 rounded"
        bind:value={typeName}
        placeholder="ชื่อกลุ่ม"
      />

      <p>querySearch</p>
      <input
        type="text"
        class="p-2 my-1 rounded"
        bind:value={querySearch}
        placeholder="querySearch * ?group=สินค้าลดราคา"
      />

      <div class="flex items-center">
        ไอคอนชื่อ (Url Image)
        {#if iconGroupUrl}
          <img class="w-10 h-10 mx-4 rounded" src={iconGroupUrl} />
        {/if}
      </div>
      <input
        type="text"
        class="p-2 my-1 rounded"
        bind:value={iconGroupUrl}
        placeholder="ไอคอนชื่อ (Url Image)"
      />

      <div class="flex items-center w-full p-2 justify-between">
        แสดงสำหรับ {showFor}
        <div class="p-2 my-1 rounded">
          <select
            bind:value={showFor}
            class="block w-52 text-gray-700 py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-primary-500 focus:border-primary-500"
            name="animals"
          >
            <option value=""> Select an options </option>
            <option value="all"> ทั้งหมด </option>
            <option value="userRegister"> สมาชิก </option>
          </select>
        </div>
      </div>

      <div class="w-full sm:flex md:flex lg:flex">
        <button
          class="bg-green-500 hover:bg-green-600 text-white p-2 cursor-pointer w-full"
          on:click={createType}
          disabled={!typeName || !iconGroupUrl || !showFor || !querySearch}>create</button
        >
        {#if selectedProductGroup?.uuid}
          <button
            class="bg-yellow-500 hover:bg-yellow-600 text-white p-2 cursor-pointer w-full"
            on:click={updateType}
            disabled={!typeName || !iconGroupUrl || !showFor || !querySearch}
            >update</button
          >
          <button
            class="bg-red-500 hover:bg-red-600 text-white p-2 cursor-pointer w-full"
            on:click={removeType}
            disabled={!selectedProductGroup}>delete</button
          >
        {/if}
      </div>
    {/if}
  </div>
</div>
